%{?mingw_package_header}

%global win32_shared_dir %{_builddir}/mingw32-%{name}-%{version}-%{release}
%global win32_static_dir %{_builddir}/mingw32-%{name}-static-%{version}-%{release}
%global win64_shared_dir %{_builddir}/mingw64-%{name}-%{version}-%{release}
%global win64_static_dir %{_builddir}/mingw64-%{name}-static-%{version}-%{release}

%global pkgname glew

Name:          mingw-%{pkgname}
Version:       1.10.0
Release:       3%{?dist}
Summary:       MinGW Windows GLEW library
License:       BSD and MIT
Group:         Development/Libraries
BuildArch:     noarch
URL:           http://glew.sourceforge.net
Source0:       http://downloads.sourceforge.net/%{pkgname}/%{pkgname}-%{version}.tgz
# - Support DESTDIR
# - Fix library name
# - Don't strip glew.exe, visualinfo.exe on install (see See https://lists.fedoraproject.org/pipermail/mingw/2013-June/007007.html)
Patch0:        glew-1.10.0_makefile.patch
# Adds a makefile config for creating the static library, plus other mingw makefile fixes
Patch1:        glew-1.10.0_makefile-mingw.patch
# Remove glu requirement in pkgconfig file
Patch2:        glew-1.10.0_glu.patch

BuildRequires: mingw32-filesystem >= 95
BuildRequires: mingw32-gcc

BuildRequires: mingw64-filesystem >= 95
BuildRequires: mingw64-gcc


%description
MinGW Windows GLEW library.


%package -n mingw32-%{pkgname}
Summary:       MinGW Windows GLEW library

%description -n mingw32-%{pkgname}
MinGW Windows GLEW library.


%package -n mingw32-%{pkgname}-static
Summary:       Static version of MinGW Windows GLEW library
Requires:      mingw32-%{pkgname} = %{version}-%{release}

%description -n mingw32-%{pkgname}-static
Static version of MinGW Windows GLEW library.


%package -n mingw32-%{pkgname}-tools
Summary:       Tools for the MinGW Windows GLEW library
Requires:      mingw32-%{pkgname} = %{version}-%{release}

%description -n mingw32-%{pkgname}-tools
Tools for the MinGW Windows GLEW library.


%package -n mingw64-%{pkgname}
Summary:       MinGW Windows GLEW library

%description -n mingw64-%{pkgname}
MinGW Windows GLEW library.


%package -n mingw64-%{pkgname}-static
Summary:       Static version of MinGW Windows GLEW library
Requires:      mingw64-%{pkgname} = %{version}-%{release}

%description -n mingw64-%{pkgname}-static
Static version of MinGW Windows GLEW library.


%package -n mingw64-%{pkgname}-tools
Summary:       Tools for the MinGW Windows GLEW library
Requires:      mingw64-%{pkgname} = %{version}-%{release}

%description -n mingw64-%{pkgname}-tools
Tools for the MinGW Windows GLEW library.


%{?mingw_debug_package}


%prep
%setup -q -n %{pkgname}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
cp -a . %{win32_shared_dir}
cp -a . %{win32_static_dir}
cp -a . %{win64_shared_dir}
cp -a . %{win64_static_dir}

pushd %{win32_shared_dir}
%{mingw32_make} %{?_smp_mflags} SYSTEM=mingw \
    CFLAGS.EXTRA="$CFLAGS $CXXFLAGS" STRIP= \
    GLEW_PREFIX=%{mingw32_prefix} \
    INCDIR=%{mingw32_includedir}/GL \
    LIBDIR=%{mingw32_libdir} \
    BINDIR=%{mingw32_bindir} \
    DESTDIR=%{buildroot}
popd

pushd %{win32_static_dir}
%{mingw32_make} %{?_smp_mflags} SYSTEM=mingw-static \
    CFLAGS.EXTRA="$CFLAGS $CXXFLAGS" STRIP= \
    GLEW_PREFIX=%{mingw32_prefix} \
    INCDIR=%{mingw32_includedir}/GL \
    LIBDIR=%{mingw32_libdir} \
    BINDIR=%{mingw32_bindir} \
    DESTDIR=%{buildroot}
popd

pushd %{win64_shared_dir}
%{mingw64_make} %{?_smp_mflags} SYSTEM=mingw \
    CFLAGS.EXTRA="$CFLAGS $CXXFLAGS" STRIP= \
    GLEW_PREFIX=%{mingw64_prefix} \
    INCDIR=%{mingw64_includedir}/GL \
    LIBDIR=%{mingw64_libdir} \
    BINDIR=%{mingw64_bindir} \
    DESTDIR=%{buildroot}
popd

pushd %{win64_static_dir}
%{mingw64_make} %{?_smp_mflags} SYSTEM=mingw-static \
    CFLAGS.EXTRA="$CFLAGS $CXXFLAGS" STRIP= \
    GLEW_PREFIX=%{mingw64_prefix} \
    INCDIR=%{mingw64_includedir}/GL \
    LIBDIR=%{mingw64_libdir} \
    BINDIR=%{mingw64_bindir} \
    DESTDIR=%{buildroot}
popd


%install
pushd %{win32_shared_dir}
%{mingw32_make} install.all SYSTEM=mingw STRIP= \
    GLEW_PREFIX="%{mingw32_prefix}" \
    INCDIR=%{mingw32_includedir}/GL \
    LIBDIR=%{mingw32_libdir} \
    BINDIR=%{mingw32_bindir} \
    DESTDIR=%{buildroot}
popd

pushd %{win32_static_dir}
%{mingw32_make} install.all SYSTEM=mingw-static STRIP= \
    GLEW_PREFIX="%{mingw32_prefix}" \
    INCDIR=%{mingw32_includedir}/GL \
    LIBDIR=%{mingw32_libdir} \
    BINDIR=%{mingw32_bindir} \
    DESTDIR=%{buildroot}
popd

pushd %{win64_shared_dir}
%{mingw64_make} install.all SYSTEM=mingw STRIP= \
    GLEW_PREFIX="%{mingw64_prefix}" \
    INCDIR=%{mingw64_includedir}/GL \
    LIBDIR=%{mingw64_libdir} \
    BINDIR=%{mingw64_bindir} \
    DESTDIR=%{buildroot}
popd

pushd %{win64_static_dir}
%{mingw64_make} install.all SYSTEM=mingw-static STRIP= \
    GLEW_PREFIX="%{mingw64_prefix}" \
    INCDIR=%{mingw64_includedir}/GL \
    LIBDIR=%{mingw64_libdir} \
    BINDIR=%{mingw64_bindir} \
    DESTDIR=%{buildroot}
popd


%files -n mingw32-%{pkgname}
%doc LICENSE.txt
%{mingw32_bindir}/glew32.dll
%{mingw32_bindir}/glew32mx.dll
%{mingw32_libdir}/pkgconfig/glew.pc
%{mingw32_libdir}/pkgconfig/glewmx.pc
%{mingw32_includedir}/GL/glew.h
%{mingw32_includedir}/GL/glxew.h
%{mingw32_includedir}/GL/wglew.h
%{mingw32_libdir}/libglew32.dll.a
%{mingw32_libdir}/libglew32mx.dll.a

%files -n mingw32-%{pkgname}-static
%{mingw32_libdir}/libglew32.a
%{mingw32_libdir}/libglew32mx.a

%files -n mingw32-%{pkgname}-tools
%{mingw32_bindir}/glewinfo.exe
%{mingw32_bindir}/visualinfo.exe

%files -n mingw64-%{pkgname}
%doc LICENSE.txt
%{mingw64_bindir}/glew32.dll
%{mingw64_bindir}/glew32mx.dll
%{mingw64_libdir}/pkgconfig/glew.pc
%{mingw64_libdir}/pkgconfig/glewmx.pc
%{mingw64_includedir}/GL/glew.h
%{mingw64_includedir}/GL/glxew.h
%{mingw64_includedir}/GL/wglew.h
%{mingw64_libdir}/libglew32.dll.a
%{mingw64_libdir}/libglew32mx.dll.a

%files -n mingw64-%{pkgname}-static
%{mingw64_libdir}/libglew32.a
%{mingw64_libdir}/libglew32mx.a

%files -n mingw64-%{pkgname}-tools
%{mingw64_bindir}/glewinfo.exe
%{mingw64_bindir}/visualinfo.exe


%changelog
* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.10.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Aug 19 2013 Sandro Mani <manisandro@gmail.com> - 1.10.0-2
- Remove glu requirement in pkgconfig file

* Thu Aug 08 2013 Sandro Mani <manisandro@gmail.com> - 1.10.0-1
- Update to 1.10.0

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.9.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sun Jun 30 2013 Sandro Mani <manisandro@gmail.com> - 1.9.0-5
- Don't strip glew.exe visualinfo.exe on install

* Fri May 17 2013 Sandro Mani <manisandro@gmail.com> - 1.9.0-4
- Pass correct CFLAGS

* Thu May 09 2013 Sandro Mani <manisandro@gmail.com> - 1.9.0-3
- Remove mingw_build_win32/64 macros
- Properly version mingw32-filesystem BuildRequires
- Reword win32/64_dynamic_dir to win32/64_shared_dir

* Thu May 09 2013 Sandro Mani <manisandro@gmail.com> - 1.9.0-2
- Spec updates

* Thu Feb 28 2013 Sandro Mani <manisandro@gmail.com> - 1.9.0-1
- Update to 1.9.0

* Sat Aug 18 2012 Sandro Mani <manisandro@gmail.com> - 1.7.0-1
- Update to 1.7.0
- Enable Win64 build

* Mon May 28 2012 Sandro Mani <manisandro@gmail.com> - 1.6.0-4
- Packaging fixes

* Thu May 24 2012 Sandro Mani <manisandro@gmail.com> - 1.6.0-3
- Packaging fixes

* Thu May 24 2012 Sandro Mani <manisandro@gmail.com> - 1.6.0-2
- Packaging fixes

* Thu May 24 2012 Sandro Mani <manisandro@gmail.com> - 1.6.0-1
- Initial build
